r9.maker ={};

//Coreエンジン
r9.maker.core = {
	
	order_list:{},
	
	
	init:function(param_map){
		
		
		var button_game_start =$("<input type='button' style='width:140px;height:70px' value='ゲームを実行する' />");
		
		button_game_start.click(function(ev){
		
			//テキストエリアから、命令配列を取得しまっす。
			//これで、ゲームは始まります、、、が。
			
			//ルートディレクトリ
			var game_dir = $("#text_game_folder").val();
			
			if(game_dir ===""){
				alert("ゲームフォルダ名を入力してください");
				return false;
			}
			
			r9_path_define(game_dir,r9);// ルートパスの再定義
			
			game.base={};
			
			game.error="";
			
			if(game.preloader){
				game.preloader.clear(); //プリローダーをクリア
			}
			
			game.init("game_maker");
			
			
									
		});
				
		
		$("#game_start_area").append(button_game_start);
		
		for(var order_type in r9.order){
			this.order_list[r9.order[order_type].order] = r9.order[order_type];
		}
		
		
	},
	
	//命令をセットする
	setOrder:function(order){
		
		
		if(this.order_list[order]){
			
			
			var order_obj = object(this.order_list[order]);
			var order_str = "#"+order+":";
			var param_str = "";
			var array_param = [];
			
			for(var i=0;i<order_obj.vital.length;i++){
				array_param.push(order_obj.vital[i]+"= ");
			}
			
			param_str = array_param.join(",");
			
			order_str +=param_str;
			
			//テキストの所定の位置に値を挿入
			
			$('#textarea_story').insertAtCaret("\n"+order_str+"");
		
			//命令セットの配置
			var html ="【パラメータ候補】";
			
			var array_pm = order_obj.pm;
			
			for(var i=0;i<array_pm.length;i++){
				
				//html+="<span style='font-size:12px;'><a style='text-decoration:none;color:blue' href='javascript:void(0);return false;' onclick='game_maker.addPm(\""+array_pm[i]+"\");'  >"+ array_pm[i] +"</a></span>　";
				html+="<input type='button' onclick='game_maker.addPm(\""+array_pm[i]+"\");' value='"+array_pm[i]+"' />";
				
			}
			
			var help_url = encodeURI("http://r9game.com/?p=89#"+order+"");
			
			//ヘルプ
			html +="<div style='float:right'>【HELP】<span style='font-size:12px'><a style='text-decoration:none;color:blue' href='"+help_url+"' target='help_frame' >「"+order+"」の解説</a></span></div>";
		
			
		
			$("#more_info_area").html(html);
			
		
		}
		
		
	},
	
	//必須でないパラメータを付加できる
	addPm:function(order){
		
		$('#textarea_story').insertAtCaret(", "+order+"= ");
		
	},
	
	debugOrder:function(obj){
		
		$("#text_order_current").val(obj.current);
		$("#text_order_next").val(obj.next);
		$("#text_order_next2").val(obj.next2);
		
	},
	
	checkRow:function(){
		var gyosuu = $('#textarea_story').getCurrentRow();
		$("#row_num").html("行番号："+gyosuu);
	}

		
};


$.fn.extend({
    insertAtCaret: function(v) {
        var o = this.get(0);
        o.focus();
        if (jQuery.browser.msie) {
            var r = document.selection.createRange();
            
            r.text = v;
            r.select();
        } else {
            var s = o.value;
            var p = o.selectionStart;
            var np = p + v.length;
            
            //ここまでの文字列は取得できますね
            
            o.value = s.substr(0, p) + v + s.substr(p);
            o.setSelectionRange(np, np);
        }
        
        $("#textarea_story").getCurrentRow();
    }


});

$.fn.extend({
    getCurrentRow: function(v) {
		
        var o = this.get(0);
        o.focus();
        var s = o.value;
        var p = o.selectionStart;
        //ここまでの文字列は取得できますね
        var str = s.substr(0, p); 
        
        var num =str.match(/\r\n|\n/g);
       
        var gyosuu = 1;
        
        if(num!=null){gyosuu = num.length +1; }
     　 else{gyosuu = 1;}
        
        return gyosuu;
		
    }


});




var game_maker = object(r9.maker.core);
game_maker.init(); 

$(window).bind('beforeunload', function(e) {
    return "編集を終えてよろしいですね？作成したゲームコードは別のファイルに保存しないと消失します。";
});


//setInterval(game_maker.checkRow,50);
